//////////////////////////////////////////////////////////////////////////////////////////////////////////////
var selDashboardPm = {
    chkDate: ".chk-tog-date",
    chkName: ".chk-tog-name",
    chkType: ".chk-tog-type",
    chkVendor: ".chk-tog-vendor",
    chkAs: ".chk-tog-as",
    chkAd: ".chk-tog-ad",
    chkStatus: ".chk-tog-status",
    chkAction: ".chk-tog-action",
    chkImpact: ".chk-tog-vimpact",
    chkGrpPatch: ".chk-grp-ptch",

    dateCell: ".cell-date",
    nameCell: ".cell-name",
    typeCell: ".cell-type",
    vendorCell: ".cell-vendor",
    asCell: ".cell-as",
    adCell: ".cell-ad",
    statusCell: ".cell-status",
    actionCell: ".cell-action",
    impactCell: ".cell-vimpact",
    tableContainerBody: ".table-container-body",
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

var generatingData = false;

function GeneratePatchUpdateData() {
    if (!generatingData) {
        generatingData = true;

        $.ajax({
            async: true,
            type: 'GET',
            url: ActionURLS.DashboardPatchManagement.GeneratePatchUpdateTempData,
            success: function (result) {
                showUiMsg("content", "success", "Data generated", "", "", "", UISettings.MsgTimeToLiveMs);
                GetAllPatches(true);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console && console.log("GeneratePatchUpdateData failed: " + thrownError);
            }
        });
    }
}

function GetAllPatches(initCharts, callback) {

    $.ajax({
        async: true,
        type: 'GET',
        url: ActionURLS.DashboardPatchManagement.GetPatchesAndUpdates,
        success: function (result) {
            if (result.Success == "OK") {
                if (angularSEP.Scope[angularSEP.ControllerDashboardPatches] != null) {
                    try {

                        console.log('PM Service Enabled: ' + result.Patches.ServiceEnabled);

                        if (!result.Patches.ServiceEnabled) {
                            hideDashboardNoData();
                            showDashboardNoService();

                        } else {
                            if (result.Patches.PatchUpdatesTable.length == 0)
                                showTableNoData();

                            angularSEP.Scope[angularSEP.ControllerDashboardPatches].limitVal = 50;
                            angularSEP.Scope[angularSEP.ControllerDashboardPatches].patchUpdates = result.Patches.PatchUpdatesTable;
                            angularSEP.Scope[angularSEP.ControllerDashboardPatches].predicate = result.Patches.UserSettingsModel.Predicate;
                            angularSEP.Scope[angularSEP.ControllerDashboardPatches].reverse = result.Patches.UserSettingsModel.SortAscending;
                            angularSEP.Scope[angularSEP.ControllerDashboardPatches].vendordDDList = result.Patches.VendorsList;
                            angularSEP.Scope[angularSEP.ControllerDashboardPatches].$apply();

                            if (initCharts) {
                                if ((result.Patches.SeverityDonutModel.TotalCritical == 0) && (result.Patches.SeverityDonutModel.TotalImportant == 0) && (result.Patches.SeverityDonutModel.TotalModerate == 0) && (result.Patches.SeverityDonutModel.TotalLow == 0) && (result.Patches.SeverityDonutModel.TotalUndefined == 0))
                                    showPieChartNoData();

                                InitialiseSeverityChart(result.Patches.SeverityDonutModel.TotalCritical, result.Patches.SeverityDonutModel.TotalImportant, result.Patches.SeverityDonutModel.TotalModerate, result.Patches.SeverityDonutModel.TotalLow, result.Patches.SeverityDonutModel.TotalUndefined);
                                InitialiseNetworkStateChart(result.Patches.StatusDonutModel.TotalApproved, result.Patches.StatusDonutModel.TotalIgnored, result.Patches.StatusDonutModel.TotalMissing, result.Patches.StatusDonutModel.TotalInstalled, result.Patches.StatusDonutModel.TotalFailed);

                                $(selTables.tableActions).hide();
                            }
                        }

                        LoadVisibleColumns(result.Patches.UserSettingsModel.VisibleColumns);

                        hidePageContentLoader();
                    }
                    catch (err) {
                        hidePageContentLoader();
                        showUiMsg("content", "critical", "Get all updates failed with: " + err.message, "", "");
                        showDashboardNoData();
                    }
                }
            }
            else {
                hidePageContentLoader();
                showUiMsg("content", "critical", result.ErrorMsg, "", "");
                showDashboardNoData();
            }

            if (callback) {
                callback();
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            hidePageContentLoader();
            showDashboardNoData();
            showUiMsg("content", "critical", thrownError.message, "", "");

            if (callback) {
                callback();
            }
        }
    });
}

function LoadVisibleColumns(visCols) {
    var splitCols = visCols.split(",");

    bypassSetVisibile = true;

    for (var i = 0; i < splitCols.length; i++) {

        if ($.inArray("vimpact", splitCols) == -1) {
            $(selDashboardPm.chkImpact).icheck("unchecked");
            hideColumn('#patch-mgmt-dash-table', selDashboardPm.impactCell);
        }
        else {
            showColumn('#patch-mgmt-dash-table', selDashboardPm.impactCell);
            $(selDashboardPm.chkImpact).icheck("checked");
        }

        if ($.inArray("date", splitCols) == -1) {
            $(selDashboardPm.chkDate).icheck("unchecked");
            hideColumn('#patch-mgmt-dash-table', selDashboardPm.dateCell);
        }
        else {
            showColumn('#patch-mgmt-dash-table', selDashboardPm.dateCell);
            $(selDashboardPm.chkDate).icheck("checked");
        }

        if ($.inArray("type", splitCols) == -1) {
            $(selDashboardPm.chkType).icheck("unchecked");
            hideColumn('#patch-mgmt-dash-table', selDashboardPm.typeCell);
        }
        else {
            $(selDashboardPm.chkType).icheck("checked");
            showColumn('#patch-mgmt-dash-table', selDashboardPm.typeCell);
        }

        if ($.inArray("vendor", splitCols) == -1) {
            $(selDashboardPm.chkVendor).icheck("unchecked");
            hideColumn('#patch-mgmt-dash-table', selDashboardPm.vendorCell);
        }
        else {
            $(selDashboardPm.chkVendor).icheck("checked");
            showColumn('#patch-mgmt-dash-table', selDashboardPm.vendorCell);
        }

        if ($.inArray("as", splitCols) == -1) {
            $(selDashboardPm.chkAs).icheck("unchecked");
            hideColumn('#patch-mgmt-dash-table', selDashboardPm.asCell);
        }
        else {
            $(selDashboardPm.chkAs).icheck("checked");
            showColumn('#patch-mgmt-dash-table', selDashboardPm.asCell);
        }

        if ($.inArray("ad", splitCols) == -1) {
            $(selDashboardPm.chkAd).icheck("unchecked");
            hideColumn('#patch-mgmt-dash-table', selDashboardPm.adCell);
        }
        else {
            $(selDashboardPm.chkAd).icheck("checked");
            showColumn('#patch-mgmt-dash-table', selDashboardPm.adCell);
        }

        if ($.inArray("ptch", splitCols) == -1) {
            $(selDashboardPm.chkGrpPatch).icheck("unchecked");
            $(selDashboardPm.tableContainerBody).removeClass("grouped-by-patch");
        }
        else {
            $(selDashboardPm.chkGrpPatch).icheck("checked");
            $(selDashboardPm.tableContainerBody).addClass("grouped-by-patch");
        }
    }

    bypassSetVisibile = false;
}

var filterDtFrom = null;
var filterDtTo = null;
var filterGrpGuids = null;
var selectedCategory = "all";

function MatchingGuids(item, filteredGuids) {
    var totalFiltDev = 0;

    for (i = 0; i < item.GroupCounts.length; i++) {

        if (filteredGuids.length == 0) {
            totalFiltDev += item.GroupCounts[i].GroupCount;
        }
        else {
            var result = $.inArray(item.GroupCounts[i].GroupGuid, filteredGuids)

            if (result > -1)
                totalFiltDev += item.GroupCounts[i].GroupCount;
        }
    }

    if (totalFiltDev == 0)
        return false;
    else {
        item.AffectedDevices = totalFiltDev;
        return true;
    }
}

var pid = "";
var deviceName = "";
var devicesPerPatch;

function DatePickerUpdated(dateRange, inst) {

    var dt = dateRange.start;
    dt.setHours(0);
    dt.setMinutes(0);
    filterDtFrom = ((dt.getTime() * 10000) + 621355968000000000);
    $(inst).parents("#filter-daterange").data("selectedFrom", filterDtFrom);

    dt = dateRange.end;
    dt.setHours(23);
    dt.setMinutes(59);
    filterDtTo = ((dt.getTime() * 10000) + 621355968000000000);

    $(inst).parents("#filter-daterange").data("selectedTo", filterDtTo);

    angularSEP.Scope[angularSEP.ControllerDashboardPatches].$apply();

    createFilterFromDaterange();
}

function GroupGuidsUpdated(guid, addGuid, target, filterName) {
    if (filterGrpGuids == null)
        filterGrpGuids = [];

    if (addGuid)
        filterGrpGuids.push(guid);
    else {
        for (var i = 0; i < filterGrpGuids.length; i++) {
            if (filterGrpGuids[i] == guid) {
                filterGrpGuids.splice(i, 1);
                break;
            }
        }
    }

    $(target).parents("#filter-groups").data("selected", filterGrpGuids.join('|'));

    angularSEP.Scope[angularSEP.ControllerDashboardPatches].$apply();
}

function ClearGroupGuids() {

    var selectedGroups = $("div.filter-block.btn-open-group-tree-card");

    for (var i = 0; i < selectedGroups.length; i++) {
        GroupGuidsUpdated(selectedGroups[i].attributes["data-guid"].value, false, $("i.fa.fa-times.btn-remove-group-filter"));
    }
}

function ForceScanOnEntireNetwork() {
    var token = $('[name=__RequestVerificationToken]').val();
    var headers = {};
    headers["__RequestVerificationToken"] = token;

    $.ajax({
        type: 'POST',
        dataType: 'json',
        processData: false,
        headers: headers,
        async: false,
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({ jsonresult: 1 }),
        url: ActionURLS.DashboardPatchManagement.ForceScanEntireNetwork + "?jsonresult=1",
        success: function (result) {
            if (result.Success == "OK") {
                showUiMsg("content", "success", "Patch scan successfully started!", "", "", "", UISettings.MsgTimeToLiveMs);
            }
            else {
                showUiMsg("content", "critical", result.ErrorMsg, "", "", "", UISettings.MsgTimeToLiveMs);
            }
        },
        error: function (xhr, ajaxOptions, thrownError) {
            showUiMsg("content", "critical", thrownError.message, "", "", "", UISettings.MsgTimeToLiveMs);
            console && console.log("ForceScanOnEntireNetwork failed: " + thrownError);
        }
    });
}

function SortingUpdated(target, order) {
    var ngController = $(target).parents('[ng-controller]');
    var specificCtrl = ngController.attr('ng-controller');
    var predicate = $(target).data("sort");

    angularSEP.Scope[specificCtrl].predicate = predicate;
    angularSEP.Scope[specificCtrl].reverse = order;
    angularSEP.Scope[specificCtrl].$apply();

    UpdateVisibileColumns();

    UpdatePMDashUserSettings(predicate, order, null);

    return true;
}

function UpdatePMDashUserSettings(predicate, sortAscending, visibleCol) {
    try {

        var PMDashUserSettingsModel = {
            Predicate: predicate,
            SortAscending: sortAscending,
            VisibleColumns: visibleCol
        };

        $.ajax({
            type: 'POST',
            dataType: 'json',
            processData: false,
            async: true,
            contentType: "application/json; charset=utf-8",
            url: ActionURLS.UserSettings.SetPMDashUserSettings,
            data: JSON.stringify({ model: PMDashUserSettingsModel }),
            success: function (result) {
                if (result.Success == "OK") {
                    console.log("UpdatePMDashUserSettings Success");
                }
                else
                    console.log("UpdatePMDashUserSettings failed: " + result.ErrorMsg);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                console && console.log("UpdatePMDashUserSettings failed: " + thrownError);
            }
        });
    }
    catch (err) {
        console && console.log("UpdatePMDashUserSettings failed: " + err);
    }
}



var bypassSetVisibile = false;

function SetVisibleColumns() {
    if (!bypassSetVisibile) {
        var checkedCols = $(".column-select-dropdown").find(".checked");
        var visColString = " ";

        for (var i = 0; i < checkedCols.length; i++) {

            if (visColString != "")
                visColString += ",";

            visColString += $(checkedCols[i]).children().data("colfil");
        }

        UpdatePMDashUserSettings(null, null, visColString);
    }
}

function OpenPMFilterGroupsTreeCard() {
    treeCardCheckIfNodeSelected = false;
    $("#btnSelectGroup").removeAttr("disabled");

    InitGroupFilterTree();

    $("#btnSelectGroup").off("click");
    $("#btnSelectGroup").on("click", function () {
        addGroupFilter($("#dash-pm-filters").parent());
        checkActiveFiltersCount();
        closeCards();
        treeCardCheckIfNodeSelected = true;
    });

    return true;
}

function DashboardCloseTableSearch() {
    angularSEP.Scope[angularSEP.ControllerDashboardPatches].searchTextDashboardPatches = "";
    angularSEP.Scope[angularSEP.ControllerDashboardPatches].$apply();
    UpdateVisibileColumns();
}

function DashboardTableSearchUpdated() {
    UpdateVisibileColumns();
}

function InitialiseDashboardPm(containerSelector) {
    pid = "";
    devicesPerPatch = null;
    MoveTreeInit = false;

    //InitialiseSideNav(containerSelector);
    InitialiseICheck(containerSelector);

    InitialiseCards(containerSelector, {
        fnOpenPatchCard: GetPatchCardData, fnOpenDeviceCard: LoadDeviceInfo,
        fnOpenGroupsTreeCard: OpenPMFilterGroupsTreeCard, fnBackCard: LoadPreviousCard,
        fnCloseAllCards: ResetCardsHistory
    });
    InitialiseTabs(containerSelector);

    InitialiseFilters(containerSelector + " .filtering-container", {
        fnAddFilterTag: AddPMFilterTag,
        fnRemoveFilterTag: RemovePMFilterTag,
        fnClearAllFiltersTags: ClearAllPMFiltersTags
    });

    InitialiseTables(containerSelector, {
        //id: "dashboardpm-page",
        fnCategoriesUpdated: CategoriesUpdated,
        fnSortingUpdated: SortingUpdated,
        fnCloseTableSearch: DashboardCloseTableSearch,
        fnTableSearchUpdated: DashboardTableSearchUpdated
    });

    $(containerSelector).off("click", selTables.tableHead);

    InitialiseDateTimePicker(containerSelector, DatePickerUpdated);

    InitialiseForms(containerSelector);

    InitialiseAngularPatchTable(angularSEP.ControllerDashboardPatches);

    InitialisePatchInstallsChart();

    GetAllPatches(true);

    //Hide show column
    $(containerSelector).off("ifChecked", selDashboardPm.chkDate);
    $(containerSelector).on("ifChecked", selDashboardPm.chkDate, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.dateCell);
    });

    $(containerSelector).off("ifUnchecked", selDashboardPm.chkDate);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkDate, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.dateCell);
    });

    $(containerSelector).off("ifChecked", selDashboardPm.chkName);
    $(containerSelector).on("ifChecked", selDashboardPm.chkName, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.nameCell);
    });

    $(containerSelector).off("ifUnchecked", selDashboardPm.chkName);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkName, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.nameCell);
    });

    $(containerSelector).off("ifChecked", selDashboardPm.chkType);
    $(containerSelector).on("ifChecked", selDashboardPm.chkType, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.typeCell);
    });

    $(containerSelector).off("ifUnchecked", selDashboardPm.chkType);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkType, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.typeCell);
    });

    $(containerSelector).off("ifChecked", selDashboardPm.chkVendor);
    $(containerSelector).on("ifChecked", selDashboardPm.chkVendor, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.vendorCell);
    });

    $(containerSelector).off("ifUnchecked", selDashboardPm.chkVendor);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkVendor, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.vendorCell);
    });

    $(containerSelector).off("ifChecked", selDashboardPm.chkAs);
    $(containerSelector).on("ifChecked", selDashboardPm.chkAs, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.asCell);
    });
    $(containerSelector).off("ifUnchecked", selDashboardPm.chkAs);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkAs, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.asCell);
    });

    $(containerSelector).off("ifChecked", selDashboardPm.chkAd);
    $(containerSelector).on("ifChecked", selDashboardPm.chkAd, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.adCell);
    });

    $(containerSelector).off("ifUnchecked", selDashboardPm.chkAd);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkAd, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.adCell);
    });

    $(containerSelector).off("ifChecked", selDashboardPm.chkStatus);
    $(containerSelector).on("ifChecked", selDashboardPm.chkStatus, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.statusCell);
    });

    $(containerSelector).off("ifUnchecked", selDashboardPm.chkStatus);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkStatus, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.statusCell);
    });
    $(containerSelector).off("ifChecked", selDashboardPm.chkAction);
    $(containerSelector).on("ifChecked", selDashboardPm.chkAction, function () {
        SetVisibleColumns();
        showColumn('#patch-mgmt-dash-table', selDashboardPm.actionCell);
    });
    $(containerSelector).off("ifUnchecked", selDashboardPm.chkAction);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkAction, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.actionCell);
    });

    //Impact check
    $(containerSelector).off("ifChecked", selDashboardPm.chkImpact);
    $(containerSelector).on("ifChecked", selDashboardPm.chkImpact, function () {
        SetVisibleColumns();
        showColumn(selDashboardPm.impactCell);
    });

    //Impact uncheck
    $(containerSelector).off("ifUnchecked", selDashboardPm.chkImpact);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkImpact, function () {
        SetVisibleColumns();
        hideColumn('#patch-mgmt-dash-table', selDashboardPm.impactCell);
    });


    $(containerSelector).off("ifChecked", selDashboardPm.chkGrpPatch);
    $(containerSelector).on("ifChecked", selDashboardPm.chkGrpPatch, function () {
        SetVisibleColumns();
        $(selDashboardPm.tableContainerBody).addClass("grouped-by-patch");
    });
    $(containerSelector).off("ifUnchecked", selDashboardPm.chkGrpPatch);
    $(containerSelector).on("ifUnchecked", selDashboardPm.chkGrpPatch, function () {
        SetVisibleColumns();
        $(selDashboardPm.tableContainerBody).removeClass("grouped-by-patch");
    });

    $(containerSelector + " .table-container-body").bind("scroll", function () {
        //if 100px remain, start loading more devices
        if ($(this).scrollTop() + $(this).innerHeight() >= this.scrollHeight - 100) {
            angularSEP.Scope[angularSEP.ControllerDashboardPatches].LoadMore();
        }

        //check scrollbar position to edit scroll shadow
        var thisItem = $(this);
        checkScrollShadowPos(thisItem);
    });


    console.log("Init. Dashboard - Patch Management");
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

InitialiseDashboardPm("#updateContent");